void loadsna(std::string sfnam) {
	std::ifstream file(sfnam.c_str(),std::ios::binary);
	if (!file.good()) {
		QMessageBox mbx;
		mbx.setIcon(QMessageBox::Critical);
		mbx.setText("<b>Can't open file</b>");
		mbx.setInformativeText(sfnam.c_str());
		mbx.exec();
		return;
	}
	char *tarr = new char[0x4000];
	ireg = file.get();
	alt[5] = file.get(); alt[4] = file.get();
	alt[3] = file.get(); alt[2] = file.get();
	alt[1] = file.get(); alt[0] = file.get();
	alt[6] = file.get(); alt[7] = file.get();
	reg[5] = file.get(); reg[4] = file.get();
	reg[3] = file.get(); reg[2] = file.get();
	reg[1] = file.get(); reg[0] = file.get();
	reg[13] = file.get(); reg[12] = file.get();
	reg[11] = file.get(); reg[10] = file.get();
	tmp = file.get(); iff1 = iff2 = (tmp & 4);
	rreg = file.get();
	reg[6] = file.get(); reg[7] = file.get();
	reg[9] = file.get(); reg[8] = file.get();
	imode = file.get();
	tmp = file.get(); brdcol = (tmp & 7);
	file.read((char*)&mem.ram[5],0x4000);
	file.read((char*)&mem.ram[2],0x4000);
	file.read(tarr,0x4000);
	uchar snabank;
	if (file.eof()) {
		snabank=0;
		mem.currom = 1;
		mem.prt0 = 0x10;
		mem.curram = 0;
		pc=pop(0,0);
	} else {
		tmp = file.get(); tmp2 = file.get(); pc = tmp + (tmp2<<8);
		tmp = file.get(); snabank = (tmp & 7); out_7ffd(tmp);
		tmp = file.get(); bdi.active = (tmp & 1);
		if (snabank!=0) file.read((char*)&mem.ram[0][0],0x4000);
		if (snabank!=1) file.read((char*)&mem.ram[1][0],0x4000);
		if (snabank!=3) file.read((char*)&mem.ram[3][0],0x4000);
		if (snabank!=4) file.read((char*)&mem.ram[4][0],0x4000);
		if (snabank!=6) file.read((char*)&mem.ram[6][0],0x4000);
		if (snabank!=7) file.read((char*)&mem.ram[7][0],0x4000);
	}
	memcpy(&mem.ram[snabank][0],tarr,0x4000);
}

void savesna(std::string sfnam,bool sna48=false) {
	std::ofstream file(sfnam.c_str(),std::ios::binary);
	if (sna48) push(pc,0,0);
	file.put((char)ireg);		// i
	file.put((char)alt[5]).put((char)alt[4]).put((char)alt[3]);	// alt.regs
	file.put((char)alt[2]).put((char)alt[1]).put((char)alt[0]);
	file.put((char)alt[6]).put((char)alt[7]);
	file.put((char)reg[5]).put((char)reg[4]).put((char)reg[3]);	// regs (l,h,e,d,c,b)
	file.put((char)reg[2]).put((char)reg[1]).put((char)reg[0]);
	file.put((char)reg[13]).put((char)reg[12]);	// iy
	file.put((char)reg[11]).put((char)reg[10]);	// ix
	file.put((char)(iff2?4:0)).put((char)rreg);	// iff2,r
	file.put((char)reg[6]).put((char)reg[7]);	// f,a
	file.put((char)reg[9]).put((char)reg[8]);	// SP
	file.put((char)imode).put((char)brdcol);		// imode, border color
	file.write((char*)mem.ram[5][0],0x4000);		// 0x4000 - 0x7fff
	file.write((char*)mem.ram[2][0],0x4000);		// 0x8000 - 0xcfff
	if (sna48) {
		file.write((char*)mem.ram[0][0],0x4000);	// 0xc000 - 0xffff (48K: bank 0)
	} else {
		file.write((char*)mem.ram[mem.curram & 7][0],0x4000);	// current bank
		file.put((char)(pc&0xff)).put((char)((pc&0xff00)>>8));	// pc
		file.put((char)mem.prt0);			// 7ffd
		file.put((char)(bdi.active?0xff:0x00));
		uchar bnk = mem.curram & 7;
		if (bnk!=0) file.write((char*)mem.ram[0][0],0x4000);
		if (bnk!=1) file.write((char*)mem.ram[1][0],0x4000);
		if (bnk!=3) file.write((char*)mem.ram[3][0],0x4000);
		if (bnk!=4) file.write((char*)mem.ram[4][0],0x4000);
		if (bnk!=6) file.write((char*)mem.ram[6][0],0x4000);
		if (bnk!=7) file.write((char*)mem.ram[7][0],0x4000);
	}
}

void savesnapshot(std::string sfnam,bool sna48=false) {
	bool kformat=false;
	QString fnam(sfnam.c_str());
	if (fnam.endsWith(".sna",Qt::CaseInsensitive)) {savesna(sfnam,sna48); kformat=true;}
	if (!kformat) {sfnam.append(".sna"); savesna(sfnam,sna48);}
}
